package com.tofly.feesapi.wxgl.wechatofficalacctmgt.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.WxBtsq;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.dto.WxCommonDto;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.vo.WxBtsqVo;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.service.WxBtsqService;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;

/**
 * 微信-报停申请
 */
@RestController
@RequestMapping("/wxbtsq")
@Api(tags = "微信-报停申请接口")
public class WxBtsqController {

    @Autowired
    private WxBtsqService wxBtsqService;

    @GetMapping("/getpage")
    @ApiOperation(value = "自定义分页查询")
    public ResultRespone<Page<WxBtsqVo>> getWxBtsqPage(Page page, @ModelAttribute WxCommonDto dto) {
        ResultRespone<Page<WxBtsqVo>> resultRespone = new ResultRespone<>();
        try {
            Page<WxBtsqVo> wxghsqPage = wxBtsqService.getWxBtsqPage(page, dto);
            resultRespone.setCode(1);
            resultRespone.setResult(wxghsqPage);
        } catch (RuntimeException e) {
            resultRespone.setCode(-1);
            resultRespone.setMessage(e.getMessage());
        }
        return resultRespone;
    }

    @GetMapping("/page")
    @ApiOperation(value = "分页查询")
    public ResultRespone getWxBtsqPage(Page page, @ModelAttribute WxBtsq wxBtsq) {
        return ResultRespone.success(wxBtsqService.page(page, Wrappers.query(wxBtsq)));
    }

    @GetMapping("/{id}")
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("id") String id) {
        return ResultRespone.success(wxBtsqService.getById(id));
    }

    @ApiOperation(value = "新增微信-报停申请")
    @PostMapping
    public ResultRespone save(@RequestBody WxBtsq wxBtsq) {
        return ResultRespone.success(wxBtsqService.save(wxBtsq));
    }

    @ApiOperation(value = "修改微信-报停申请")
    @PutMapping
    public ResultRespone updateById(@RequestBody WxBtsq wxBtsq) {
        return ResultRespone.success(wxBtsqService.updateById(wxBtsq));
    }

    @ApiOperation(value = "通过ID删除微信-报停申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{id}")
    public ResultRespone removeById(@PathVariable String id) {
        return ResultRespone.success(wxBtsqService.removeById(id));
    }

    @ApiOperation(value = "通过ID批量删除微信-报停申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds")
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(wxBtsqService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
